#pragma once
#include "DTVCapture/DTV_Base.h"
#include "Common/Lock.h"
#include "Common/FileRecord.h"
#include "Common/DateTime.h"
#include <commctrl.h>
#include <vector>
#include <map>
#include <algorithm>

#ifdef _DEBUG
	#define SCHEDULE_DEBUG_PRINT	
#endif
//#define SCHEDULE_ENABLE_TIPWND		// ToolTipOffɂȂRgAEg

#define SCHEDULE_PREPROC_SEC		30	// ^JnɐsJn鎞(dA`l؂ւAP:b)
#define SCHEDULE_MARGIN_SEC			5	// ^Jn̐s^掞(xŐ擪hbvhׁAP:b)
#define SCHEDULE_MARGIN_END_SEC		1	// I̒ǉ^掞(IhbvhׁAP:b)

#ifdef SCHEDULE_ENABLE_TIPWND
	#define SCHEDULE_TIP_WIDTH			500
	#define SCHEDULE_TIP_TEXTCOLOR		RGB(0,0,0)
	#define SCHEDULE_TIP_BGCOLOR		RGB(255,255,200)
	#define SCHEDULE_TIP_NODATA			"no data"
	#define SCHEDULE_TIP_MAX_STR		1024
#endif

#define SCHEDULE_TAB_TYPE			0
#define SCHEDULE_TAB_START_TIME		1
#define SCHEDULE_TAB_DURATION_TIME	2
#define SCHEDULE_TAB_STRINGS		3

// fth
#define WM_SCHEDULE_REDRAWITEM			(WM_APP+0x00)
#define WM_SCHEDULE_PUT_TIME_AND_SEARCH	(WM_APP+0x01)

// TuACe̒ʒm
#define WM_SCHEDULE_NOTIFYSCROLL		(WM_APP+0x10)
#define WM_SCHEDULE_NOTIFYMOUSEWHEEL	(WM_APP+0x11)

struct ScheduleRecTime
{
	WORD wDate;		// EX
	DWORD dwTime;	// 0̕b
};

// Xe[^X(ǂꂩP)
#define SCHEDULE_FLAG_WAIT			(0x00000000)	// ^ҋ@
#define SCHEDULE_FLAG_PRERECORD		(0x01000000)	// ^s쒆
#define SCHEDULE_FLAG_RECORDING		(0x02000000)	// ^撆
#define SCHEDULE_FLAG_REC_SUCCESS	(0x11000000)	// ^搳I
#define SCHEDULE_FLAG_REC_ERROR		(0x12000000)	// ^G[I
#define SCHEDULE_FLAG_REC_INVALID	(0x13000000)	// ^\񖳌AFJnłȂ(Jn߂ɂ͏I߂Ă)
#define SCHEDULE_FLAG_REC_CANCEL	(0x14000000)	// LZ
#define SCHEDULE_FLAG_REC_DELETE	(0x80000000)	// I폜w(ق̂̂ɑgݍ킹tOƂĎgp)
// ^Cv(gݍ킹)
#define SCHEDULE_FLAG_DATETIME		(0x00080000)	// Œ莞
#define SCHEDULE_FLAG_EVENTID		(0x00040000)	// CxgA
#define SCHEDULE_FLAG_NEXTDAY		(0x00100000)	// (IA̓̓Ԃɗ\)
#define SCHEDULE_FLAG_NEXTWEEK		(0x00200000)	// T(IȀT̓Ԃɗ\)
// IvV(gݍ킹)
#define SCHEDULE_FLAG_USERFILENAME	(0x00000001)	// t@Cw
#define SCHEDULE_FLAG_CHANNEL		(0x00000002)	// `lݒs(ԍ)
#define SCHEDULE_FLAG_CHANNEL_STR	(0x00000004)	// `lݒs()
#define SCHEDULE_FLAG_SERVICE_ID	(0x00000008)	// T[rXIDw(pPbg}XN)
// }XN
#define SCHEDULE_FLAG_FULLBIT		(0xFFFFFFFF)	// SrbgĂ
#define SCHEDULE_FLAG_STATUSMASK	(0x7F000000)	// Xe[^X̃}XNp
#define SCHEDULE_FLAG_TYPEMASK		(0x00FF0000)	// ޕ̃}XNp
#define SCHEDULE_FLAG_OPTION		(0x0000FFFF)	// IvṼ}XNp

struct ScheduleRecItem
{
	DWORD dwFlg;
	struct		// ԂŔ(Œ莞Ԍ^)
	{
		DateTime stStart;
		DWORD dwRecSec;
	} stTime;
	struct		// EPGEventIDŔ(ԑgǏ]^)
	{
		WORD wNetworkID;	// NetworkID
		WORD wStreamID;		// TsStreamID
		WORD wServiceID;	// ServiceID
		WORD wEventID;		// EventID
		//
		BYTE byType;
		BYTE byVersion;
		char szEventName[81];	// Cxg
	} stEvent;

    char szDir[MAX_PATH];	// ۑtH_
	char szFile[MAX_PATH];	// ۑt@C(gq)
	char szExt[MAX_PATH];	// ۑt@C̊gq
	BYTE byChannel;			// `lԍ
	char szChannnelStr[80];	// `l
	char szServiceID[100];	// T[rXID
};

typedef std::vector<ScheduleRecItem> ScheduleRecList;

#ifdef SCHEDULE_ENABLE_TIPWND
struct SCHEDULE_TOOLTIP
{
	TOOLINFO stToolTipInfo;
};
typedef std::vector<SCHEDULE_TOOLTIP>	ScheduleToolTip;
#endif

// tB^wp
typedef void (CALLBACK PF_SCHEDULE_SETFILTER)(BOOL bServiceDenyFlg,WORD *pwSelectService,int iSelectServiceNum,WORD *pwDenyPidList,int iDenyPidNum,LPVOID lpContext);

// dof₢킹p
typedef BOOL (CALLBACK PF_SCHEDULE_EPGCALLBACK)(WORD wNetworkID,WORD wStreamID,WORD wServiceID,WORD wEventID,struct TSEPG_PROGRAM *pEpgData,LPVOID lpContext);

// PIDۑp
struct SCHEDULE_PMTITEM
{
	BYTE	byType;
	WORD	wPID;
};

typedef std::vector<struct SCHEDULE_PMTITEM>	SchedulePidItems;
typedef std::map<WORD,SchedulePidItems>			ScheduleServices;
typedef std::pair<WORD,SchedulePidItems>		ScheduleServicesPair;

class ScheduleRecordingObj
{
public:
	ScheduleRecordingObj()
	{
		ZeroMemory(&stItem,sizeof(stItem));
		stRecStart.Date=stRecStart.Time=0;
		pFileRecord=NULL;
		pEnableService=NULL;
		iEnableServiceNum=0;
		pDenyPID=NULL;
		iDenyNum=0;
		szRecPath[0]='\0';
	}
	~ScheduleRecordingObj()
	{
		if(pFileRecord) delete pFileRecord;
		if(pEnableService) delete []pEnableService;
		if(pDenyPID) delete []pDenyPID;
	}

public:
	struct ScheduleRecItem stItem;
	// Time
	DateTime stRecStart;
	
	// Record File
	CFileRecord *pFileRecord;

	// Filter
	WORD *pEnableService;
	int iEnableServiceNum;
	WORD *pDenyPID;
	int iDenyNum;

	// Path
	char szRecPath[MAX_PATH];
};

class CScheduleRec
{
public:
	CScheduleRec(CDTV_Base *pDTV);
	~CScheduleRec(void);

	void SetFilterCallback(PF_SCHEDULE_SETFILTER *lpFunc,LPVOID lpContext)
	{
		m_lpSetFilterFunc = lpFunc;
		m_lpSetFilterContext = lpContext;
	}
	void EpgRequestCallback(PF_SCHEDULE_EPGCALLBACK *lpFunc,LPVOID lpContext)
	{
		m_lpEpgRequestFunc = lpFunc;
		m_lpEpgRequestContext = lpContext;
	}

	BOOL IsWindowVisible() { return ::IsWindowVisible(m_hWnd); }
	BOOL ShowWindow(int iShowMode) { return ::ShowWindow(m_hWnd,iShowMode); }

	BOOL Create(HINSTANCE hInst,int iResource,HWND hParentWnd,BOOL bNoPosSize,int x,int y,int sx,int sy,int iShowMode);
	void Destroy(int *pX ,int *pY,int *pSX,int *pSY,BOOL *pbShow);

	void SetRecPath(char *lpszPath);
	void SaveSchedule(char *lpszFile=NULL);
	void LoadSchedule(char *lpszFile=NULL);

	void PutStreamID(WORD wStreamID);
	void PutNetworkID(WORD wNetworkID);
	void PutPID(WORD wServiceID,SCHEDULE_PMTITEM *pstPidList,int iPidNum);
	void PutCurrentTime(DateTime &stTime);
	BOOL PutScheduleByTime(WORD wServiceID,DateTime &stStart,DWORD dwRecTime,char *lpszName);
	BOOL PutScheduleByEventID(WORD wNetworkID,WORD wStreamID,WORD wServiceID,WORD wEventID,char *lpszName);
	void PutStream(BYTE *pbyStream,DWORD dwLen);
	void GetStatusString(char *lpszBuf,int iBufSize);

protected:
	CDTV_Base *m_pDTV;
	HINSTANCE m_hInst;
	HWND m_hWnd;
	LOCK_OBJ m_stLock;
	char m_szSaveFile[MAX_PATH];
	char m_szPath[MAX_PATH];

	PF_SCHEDULE_SETFILTER *m_lpSetFilterFunc;
	LPVOID m_lpSetFilterContext;

	PF_SCHEDULE_EPGCALLBACK *m_lpEpgRequestFunc;
	LPVOID m_lpEpgRequestContext;

	BOOL m_bScheduleRecording;
	ScheduleRecordingObj *m_pScheduleRecord;

	WORD m_wCurrentNetworkID;
	WORD m_wCurrentStreamID;
	DateTime m_stCurrentDateTime;
	ScheduleServices m_CurrentService;

	LRESULT ScheduleDlg(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
	void OnInitDialog();
	void OnSize();

	ScheduleRecList m_ScheduleList,m_RecordEndList;
	int m_iScheduleListMode;
	BOOL CheckScheduleTime(struct ScheduleRecItem *pstItem,int iIndex=-1);
	BOOL SetScheduleItem(struct ScheduleRecItem *pstItem,int iIndex=-1);
	BOOL IsRecording(int iIndex);
	BOOL RemoveScheduleItem(int iStatusFlg,int iIndex);
	void RedrawScheduleList();
	void Schedule(DateTime &stCurrentTime);
	BOOL GetDisablePids(BOOL bDenyFlg,WORD *pwServices,int iNum,WORD** ppPidList,int *piNum);	

	HWND m_hEditWnd;
	struct ScheduleRecItem m_stEditItem;
	BOOL OnScheduleAdd_ByDateTime(BOOL bSetData=FALSE,WORD wServiceID=0,DateTime *pstStart=NULL,DWORD dwRecTime=0,char *lpszName=NULL);
	BOOL OnScheduleAdd_ByEvent(WORD wNetworkID,WORD wStreamID,WORD wServiceID,WORD wEventID,char *lpszName=NULL);
	BOOL OnScheduleEdit(struct ScheduleRecItem &stEditItem);
	LRESULT ScheduleEditDlg(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);	
	BOOL OnScheduleEditInitDialog(HWND hWnd);
	BOOL GetDataFromDlg(HWND hWnd,struct ScheduleRecItem &stItem);

#ifdef SCHEDULE_ENABLE_TIPWND
	// Tip֘A
	HWND m_hTip;	
	ScheduleToolTip m_Tooltip;
	void UpdateToolTip(HWND hListView);
#endif

protected:
	// WindowProc(Dummy)
	static LRESULT CALLBACK _ScheduleDlg(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
	{
	#pragma warning(disable: 4312)
		CScheduleRec* pThis=reinterpret_cast<CScheduleRec*>(GetWindowLongPtr(hDlg,GWL_USERDATA));
	#pragma warning(default: 4312)
		if(message==WM_INITDIALOG)
		{
			{
				pThis=(CScheduleRec*)lParam;
	#pragma warning(disable: 4244)
				SetWindowLongPtr(hDlg,GWL_USERDATA,reinterpret_cast<LONG_PTR>(pThis));
	#pragma warning(default: 4244)
			}
		}
		if(pThis)
		{
			return pThis->ScheduleDlg(hDlg,message,wParam,lParam);
		} else {
			return FALSE;
		}
	}

	// WindowProc(Dummy)
	static LRESULT CALLBACK _ScheduleEditDlg(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
	{
	#pragma warning(disable: 4312)
		CScheduleRec* pThis=reinterpret_cast<CScheduleRec*>(GetWindowLongPtr(hDlg,GWL_USERDATA));
	#pragma warning(default: 4312)
		if(message==WM_INITDIALOG)
		{
			{
				pThis=(CScheduleRec*)lParam;
	#pragma warning(disable: 4244)
				SetWindowLongPtr(hDlg,GWL_USERDATA,reinterpret_cast<LONG_PTR>(pThis));
	#pragma warning(default: 4244)
			}
		}
		if(pThis)
		{
			return pThis->ScheduleEditDlg(hDlg,message,wParam,lParam);
		} else {
			return FALSE;
		}
	}
};
